angular.module('starter.controllers', ['ionic', 'ion-gallery', 'ngCordova'])

  .filter('mask', function () {
    return function (input, start, length, char) {
      input = input || '';
      if (input.length < start + length) {
        return input;
      }

      var result = [];
      for (var i = 0, len = input.length; i < len; i++) {
        if (i >= start && i <= start + length - 1) {
          result.push(char);
        } else {
          result.push(input[i]);
        }
      }
      return result.join('');
    }
  })

  .filter("img", ['xc', 'CacheService', '$rootScope', function (xc, cacheService, $rootScope) {
    return function (text) {

      var showImg = true;

      // if (netService.isMobile()) {
      //     var settings = cacheService.getItem(xc.app.settingCache) || {};
      //     showImg = settings.SHOW_IMAGE_WITH_NO_WIFI;
      // }

      if (showImg) {

        if (text)
          return xc.server.cdn + '/' + text;
        // else
        //   return 'img/logo.png';
      }
      else
        return null;
    };
  }])

  .filter("avatar", ['xc', function (xc) {
    return function (text) {
      if (text)
        return xc.server.cdn + '/' + text;
      else
        return 'img/avatar.png';
    };
  }])

  .filter('htmlFilter', ['$sce',
    function ($sce) {
      return function (text) {
        return $sce.trustAsHtml(text);
      };
    }
  ])

  //登录页面
  .controller('LoginCtrl', function ($scope, xc, UserService) {
    $scope.user = UserService.user;

    $scope.login = function () {
      UserService.login();
    };

    $scope.button = {};
    $scope.error = {};

    $scope.user = UserService.user;

    $scope.login = function () {
      UserService.login();
    };

    //手机号码输入画面
    $scope.findpwd_click = function () {
      UserService.findpwd($scope);
    };

    //关闭手机号码输入页面
    $scope.closeTelModel_click = function () {
      UserService.closeTelModel($scope);
    };

    //下一步
    $scope.next_click = function () {
      UserService.getuserInfo($scope);
    };
    $scope.closeAccountModel_click = function () {
      UserService.closeAccountModel($scope);
    };

    $scope.sendCode_click = function () {
      $scope.user.password = '';
      UserService.sendcode($scope);
    };

    //关闭重置密码弹出层
    $scope.closePwdModel_click = function () {
      UserService.closeResetPwdModel($scope);
    };

    $scope.resendCode_click = function () {
      UserService.resendCode($scope);
    };

    $scope.restPwd_click = function () {
      UserService.postPassword($scope);
    }
  })

  //首页
  .controller('HomeCtrl', function ($scope, http) {

    var topArt = {list: []};

    var items = [];

    for (var i = 0; i < 4; i++) {
      items.push({id: 0, title: '', thumbs: ''});
    }

    topArt.list = items;

    $scope.topArt = topArt;

    $scope.$on('$ionicView.afterEnter', function () {
      http.get('getBreakingArticle', {}, function (response) {
        var list = response.data.list;
        for (var i = 0, len = list.length; i < len; i++) {
          topArt.list[i].id = list[i].artId;
          topArt.list[i].thumbs = list[i].thumbs;
          topArt.list[i].title = list[i].title;
        }
      });
    });
  })

  //文章内容
  .controller('ArticleCtrl', function ($scope, $rootScope, http, $state, $timeout, $stateParams, $ionicLoading, $ionicPopup, $cordovaFile, $cordovaFileTransfer, $cordovaFileOpener2) {

    var artId = $stateParams.artId;

    $scope.art = {};

    $scope.font = {size: window.localStorage.getItem('fontSize') || 14};

    $scope.zoom = function () {
      window.localStorage.setItem('fontSize', $scope.font.size);
    };

    $scope.more = function () {
      console.log('more');
      $ionicPopup.show({
        template: '<div class="range"><i class="icon ion-ios-minus-empty"></i><input type="range" name="volume" min="9" max="32" ng-model="font.size" ng-change="zoom()"><i class="icon ion-ios-plus-empty"></i></div>',
        title: '字号调整',
        subtitle: '',
        cssClass: 'popup-font-set',
        scope: $scope,
        buttons: [
          {text: '<i class="icon ion-ios-close-outline"></i>'}
        ]
      });
    };

    $scope.stateUrl = $state.current.url.replace(':artId', '');

    $scope.$on('$ionicView.loaded', function () {
      http.get('getArticle', {artId: artId}, function (response) {
        $scope.art = response.data;
      });
    });

    $scope.$on('$ionicView.afterEnter', function () {
      console.log('$ionicView.afterEnter');
      http.get('getRandArticleList', {
        exceptId: $scope.art.artId,
        creator: $scope.art.creator,
        keyword: $scope.art.keyword,
        lang: $scope.art.lang,
        pageSize: 5
      }, function (res) {
        $scope.randList = res.data.list;
      });
    });

    $scope.contentClick = function ($event) {
      if ($event.target.href) {
        var url = $event.target.href;
        var trustHosts = true;
        var options = {};
        var lastPointIndex = url.lastIndexOf('.');
        var ext = url.substr(lastPointIndex + 1, url.length - lastPointIndex);
        var fileName = hex_sha1(url) + '.' + ext;
        var targetPath = cordova.file.externalCacheDirectory + fileName;
        $cordovaFile.checkFile(cordova.file.externalCacheDirectory, fileName).then(function () {
          // success
          openFile(targetPath, ext);
        }, function () {
          // error
          $rootScope.downloadProgress = 0;
          $ionicLoading.show({
            template: '<ion-spinner icon="bubbles" class="spinner-assertive spinner spinner-bubbles"></ion-spinner><br>正在下载文件：{{downloadProgress}}%'
          });
          $cordovaFileTransfer.download(url, targetPath, options, trustHosts)
            .then(function () {
              // Success!
              console.log('Success');
              openFile(targetPath, ext);
              $ionicLoading.hide();
            }, function (err) {
              console.error('下载过程中出现错误' + JSON.stringify(err));
              $ionicLoading.hide();
            }, function (progress) {
              $timeout(function () {
                var downloadProgress = (progress.loaded / progress.total) * 100;
                $rootScope.downloadProgress = Math.floor(downloadProgress);
                console.log($rootScope.downloadProgress);

                if (downloadProgress > 99) {
                  $ionicLoading.hide();
                }
              })
            });
        });

        $event.stopPropagation();
        $event.preventDefault();
        return false;
      }
    };

    function openFile(targetPath, ext) {
      $cordovaFileOpener2.open(
        targetPath,
        'application/' + ext
      ).then(function () {
        console.log('file opened successfully');
      }, function (err) {
        console.error('打开过程中出现错误' + JSON.stringify(err));
      });
    }
  })

  //课程列表页面
  .controller('CourseListCtrl', function ($scope, $state, $stateParams, $ionicScrollDelegate, $ionicSideMenuDelegate, CourseCategoryService, UserService, ArticleService) {

    var options = {
      params: {
        module: 'course',
        cateId: $stateParams.cateId,
        pointId: 0,
        pageNo: 1
      },
      list: []
    };

    $scope.UserService = UserService.user;

    $scope.options = options;

    $scope.category = CourseCategoryService.category;

    $scope.viewTitle = $stateParams.name;

    $scope.showCate = true;

    $scope.changeCategory = function (category) {

      var isShow = false;

      if (category) {

        // 1.属于子分类的情况下,只需要判断parentId是否等于0
        //2.本身属于父级分类,但是没有子分类的情况
        if (category.parentId == '0' && category.children.length > 0 || (category.cateId == '0')) {
          isShow = true;
        }
      }

      $scope.showCate = isShow;

      options.params.pageNo = 1;

      options.params.cateId = category.cateId || $stateParams.cateId;

      ArticleService.request(options);

      $ionicSideMenuDelegate.toggleRight();

      $scope.viewTitle = category.name || $stateParams.name;

      $ionicScrollDelegate.scrollTop();
    };

    $scope.toggleRight = function () {
      $ionicSideMenuDelegate.toggleRight();
    };

    $scope.toggleLeft = function () {
      $ionicSideMenuDelegate.toggleLeft();
    };

    $scope.doRefresh = function () {
      options.always = function () {
        $scope.$broadcast("scroll.refreshComplete");
      };
      ArticleService.request(options);
    };

    $scope.nextPage = function () {
      if (options.params.isHasNext) {
        options.params.pageNo++;
        options.always = function () {
          $scope.$broadcast("scroll.infiniteScrollComplete");
        };
        ArticleService.request(options);
      }
    };

    //android create
    //init
    $scope.$on('$ionicView.loaded', function () {
      $scope.doRefresh();
      CourseCategoryService.load();
    });
  })

  //精华列表
  .controller('EssenceCtrl', function ($scope, $state, $ionicLoading, $ionicPopover, UserService, ArticleService) {
    var options = {
      params: {
        pointId: 0,
        essence: 'true'
      },
      list: []
    };

    $scope.UserService = UserService.user;

    $scope.article = options;

    $scope.viewTitle = '精华';

    $scope.doRefresh = function () {
      options.always = function () {
        $scope.$broadcast("scroll.refreshComplete");
      };
      ArticleService.request(options);
    };

    $scope.nextPage = function () {
      if (options.params.isHasNext) {
        options.params.pageNo++;
        options.always = function () {
          $scope.$broadcast("scroll.infiniteScrollComplete");
        };
        ArticleService.request(options);
      }
    };

    $scope.$on('$ionicView.loaded', function () {
      $scope.doRefresh();
    });
  })

  //专栏首页
  .controller('SpecialCtrl', function ($scope, $state, SpecialCategoryService) {

    $scope.special_click = function (cate) {
      $state.go('tab.special-list', {cateId: cate.cateId, name: cate.name});
    };

    $scope.category = SpecialCategoryService.category;

    $scope.$on('$ionicView.loaded', function () {
      SpecialCategoryService.load();
    });
  })

  //专栏列表
  .controller('SpecialListCtrl', function ($scope, $state, $stateParams, $ionicLoading, $ionicSideMenuDelegate, UserService, ArticleService) {

    var options = {
      params: {
        module: 'special',
        cateId: $stateParams.cateId,
        pointId: 0
      },
      list: []
    };

    $scope.UserService = UserService.user;

    $scope.article = options;

    $scope.viewTitle = $stateParams.name;

    $scope.hideCategory = true;

    $scope.doRefresh = function () {
      options.always = function () {
        $scope.$broadcast("scroll.refreshComplete");
      };
      ArticleService.request(options);
    };

    $scope.nextPage = function () {
      if (options.params.isHasNext) {
        options.params.pageNo++;
        options.always = function () {
          $scope.$broadcast("scroll.infiniteScrollComplete");
        };
        ArticleService.request(options);
      }
    };

    $scope.$on('$ionicView.loaded', function () {
      $scope.doRefresh();
    });
  })

  //教学管理
  .controller('TeachCtrl', function ($scope, $state, $stateParams, $ionicScrollDelegate, $ionicSideMenuDelegate, EducationCategoryService, UserService, EducationArticleService) {

    var options = {
      params: {
        cateId: $stateParams.cateId,
        pointId: UserService.user.pointId
      },
      list: []
    };

    $scope.UserService = UserService.user;

    $scope.options = options;

    $scope.category = EducationCategoryService.category;

    $scope.viewTitle = $stateParams.name;

    $scope.showCate = true;

    $scope.changeCategory = function (category) {
      var isShow = false;
      if (category) {

        // 1.属于子分类的情况下,只需要判断parentId是否等于0
        //2.本身属于父级分类,但是没有子分类的情况
        if (category.parentId == '0' && category.children.length > 0 || (category.cateId == '0')) {
          isShow = true;
        }
      }

      $scope.showCate = isShow;

      options.params.pageNo = 1;

      options.params.cateId = category.cateId || $stateParams.cateId;

      EducationArticleService.request(options);

      $ionicSideMenuDelegate.toggleRight();

      $scope.viewTitle = category.name || $stateParams.name;

      $ionicScrollDelegate.scrollTop();
    };

    $scope.toggleRight = function () {
      $ionicSideMenuDelegate.toggleRight();
    };

    $scope.toggleLeft = function () {
      $ionicSideMenuDelegate.toggleLeft();
    };

    $scope.doRefresh = function () {
      options.always = function () {
        $scope.$broadcast("scroll.refreshComplete");
      };
      EducationArticleService.request(options);
    };

    $scope.nextPage = function () {
      if (options.params.isHasNext) {
        options.params.pageNo++;
        options.always = function () {
          $scope.$broadcast("scroll.infiniteScrollComplete");
        };
        EducationArticleService.request(options);
      }
    };

    $scope.$on('$ionicView.loaded', function () {
      $scope.doRefresh();
      EducationCategoryService.load();
    });
  })

  //班级列表
  .controller('ClassListCtrl', function ($scope, http, UserService) {
    http.get('myclass', {aid: UserService.user.id}, function (response) {
      $scope.class = {list: response.data};
    });
  })

  //聊天
  .controller('ChatListCtrl', function ($scope, $ionicTabsDelegate, http, UserService, ImGroupService) {

    $ionicTabsDelegate.showBar(true);

    var options = {
      params: {
        aid: UserService.user.id
      },
      list: []
    };

    $scope.options = options;

    $scope.doRefresh = function () {
      options.always = function () {
        $scope.$broadcast("scroll.refreshComplete");
      };
      ImGroupService.request(options);
    };

    $scope.nextPage = function () {
      if (options.params.isHasNext) {
        options.params.pageNo++;
        options.always = function () {
          $scope.$broadcast("scroll.infiniteScrollComplete");
        };
        ImGroupService.request(options);
      }
    };

    $scope.$on('$ionicView.loaded', function () {
      $scope.doRefresh();
    });
  })

  //聊天
  .controller('ChatCtrl', function ($scope, $state, $stateParams, $ionicLoading, $interval, $ionicTabsDelegate, $ionicScrollDelegate, http, UserService, ImService) {

    //1.初始化ImService
    var chat = ImService;

    ImService.creatorId = UserService.user.id;
    ImService.receiverId = $stateParams.receiver;
    ImService.groupId = $stateParams.groupId;

    //1.1 绑定
    $scope.chat = chat;
    $scope.keyboardHeight = 0;
    $ionicTabsDelegate.showBar(false);

    //1.获取当前聊天组的信息

    //2.初始化家长聊天历史消息
    $scope.$on('$ionicView.loaded', function () {

      console.log('$ionicView.loaded');

      ImService.reset();

      ImService.getGroupInfo(function () {
        ImService.getHistory(function () {
          $scope.$broadcast("scroll.refreshComplete");
          $ionicScrollDelegate.$getByHandle('mainScroll').scrollBottom(false);
        });
      });
    });

    //3.加载更多消息
    $scope.loadHistory = function () {

      chat.pullingText = '下拉加载历史';

      if (chat.params.isHasNext) {

        chat.params.pageNo++;

        ImService.getHistory(function () {
          $scope.$broadcast("scroll.refreshComplete");
          $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop(true);
        });

      } else {
        chat.pullingText = '没有更多';
        $scope.$broadcast("scroll.refreshComplete");
      }
    };

    //4.绑定发送消息事件
    $scope.send = function () {
      ImService.send(function () {
        $ionicScrollDelegate.$getByHandle('mainScroll').scrollBottom(true);
      });
      return false;
    };

    //5.启动监听新消息服务
    $scope.$on('$ionicView.afterEnter', function () {
      console.log('$ionicView.afterEnter');
      ImService.startListener(function () {
        $ionicScrollDelegate.$getByHandle('mainScroll').scrollBottom(true);
      });
    });

    //6.关闭监听新消息服务
    $scope.$on('$ionicView.beforeLeave', function () {
      console.log('$ionicView.beforeLeave');
      ImService.stopListener();
    });

    //7.显示家长信息
    $scope.showUser = function () {
      console.log('显示家长信息');
      $state.go('tab.user', {userId: chat.receiverId});
    };

    //8.控制样式
    var isIPad = ionic.Platform.isIPad();
    var isIOS = ionic.Platform.isIOS();

    window.addEventListener('native.keyboardhide', keyboardHideHandler);
    window.addEventListener('native.keyboardshow', keyboardShowHandler);
    function keyboardHideHandler() {
      $scope.keyboardHeight = 0;
      $ionicScrollDelegate.$getByHandle('mainScroll').resize();
    }

    function keyboardShowHandler(e) {
      if (isIPad || isIOS)
        $scope.keyboardHeight = e.keyboardHeight;
      $ionicScrollDelegate.$getByHandle('mainScroll').scrollBottom(false);
    }
  })

  ///用户信息
  .controller('UserCtrl', function ($scope, http, $stateParams) {
    http.get('getUserInfo', {userId: $stateParams.userId}, function (response) {
      $scope.user = response.data;
    })
  })

  //学生列表
  .controller('StudentListCtrl', function ($scope, http, $stateParams) {

    var options = {
      className: ($stateParams.name || '学生列表'),
      list: []
    };

    http.get('getStudentList', {
      classid: $stateParams.id
    }, function (response) {
      options.list = response.data;
    });

    $scope.options = options;
  })

  //下载管理
  .controller('DownloadListCtrl', function ($scope, http, UserService) {

    $scope.doRefresh = function () {
      http.get('download/myclass', {
        aid: UserService.user.id
      }, function (response) {
        $scope.list = response.data;
        $scope.$broadcast("scroll.refreshComplete");
      }, function () {
        $scope.$broadcast("scroll.refreshComplete");
      });
    };

    $scope.$on('$ionicView.loaded', function () {
      $scope.doRefresh();
    });
  })

  //下载管理明细
  .controller('DownloadViewCtrl', function ($scope, http, $stateParams) {

    $scope.viewTitle = $stateParams.className + '-' + ($stateParams.type == 1 ? '已下载' : '未下载');
    $scope.theme = ($stateParams.type == 1 ? 'bar-balanced' : 'bar-calm');
    var pars = {
      classId: $stateParams.classId,
      type: $stateParams.type
    };

    $scope.doRefresh = function () {
      http.get('download/parents', pars, function (response) {
        $scope.list = response.data;
        $scope.$broadcast("scroll.refreshComplete");
      }, function () {
        $scope.$broadcast("scroll.refreshComplete");
      });
    };

    $scope.$on('$ionicView.loaded', function () {
      $scope.doRefresh();
    })
  })

  //学生列表
  .controller('StudentCtrl', function ($scope, http, $stateParams, $ionicTabsDelegate) {
    $ionicTabsDelegate.showBar(true);
    http.get('getStudentInfo', {
      studentid: $stateParams.studentId
    }, function (response) {
      $scope.student = response.data;
    });
  })

  //通知公告
  .controller('NoticeListCtrl', function ($scope, $state, $stateParams, $ionicPopup, NoticeListService, xc, UserService, NoticeService) {

    var options = {
      params: {aid: UserService.user.id},
      list: []
    };

    $scope.delete = function (index, id) {

      var confirmPopup = $ionicPopup.confirm({
        title: '确定要删除么?',
        cancelText: '取消',
        okText: '确认',
        okType: 'button-assertive'
      });

      confirmPopup.then(function (res) {
        if (res) {
          options.list.splice(index, 1);
          NoticeService.delete(id);
          confirmPopup.close();
        } else {
        }
      });
    };

    $scope.cdn = xc.server.cdn;

    $scope.UserService = UserService.user;

    $scope.options = options;

    $scope.pub = function () {
      NoticeService.open($scope);
      // $state.go('tab.notice-pub');
    };

    $scope.close = function () {
      NoticeService.close();
    };

    $scope.doRefresh = function () {
      options.always = function () {
        $scope.$broadcast("scroll.refreshComplete");
      };
      NoticeListService.request(options);
    };

    $scope.nextPage = function () {
      if (options.params.isHasNext) {
        options.params.pageNo++;
        options.always = function () {
          $scope.$broadcast("scroll.infiniteScrollComplete");
        };
        NoticeListService.request(options);
      }
    };

    $scope.$on('$ionicView.loaded', function () {
      $scope.doRefresh();
    });
  })

  .controller('NoticeViewCtrl', function ($scope, http, $stateParams) {

    return http.get('getNotice', {
      id: $stateParams.id
    }, function (response) {
      $scope.notice = response.data;
    });
  })

  //家庭作业
  .controller('HomeworkListCtrl', function ($scope, http, $stateParams, $ionicPopup, UserService, HomeworkListService, HomeworkService) {

    var options = {
      params: {aid: UserService.user.id},
      list: []
    };

    $scope.UserService = UserService.user;

    $scope.options = options;

    $scope.delete = function (index, id) {

      var confirmPopup = $ionicPopup.confirm({
        title: '确定要删除么?',
        cancelText: '取消',
        okText: '确认',
        okType: 'button-assertive'
      });

      confirmPopup.then(function (res) {
        if (res) {
          options.list.splice(index, 1);
          HomeworkService.delete(id);
          confirmPopup.close();
        } else {
        }
      });
    };

    $scope.pub = function () {
      HomeworkService.open($scope);
    };

    $scope.close = function () {
      HomeworkService.close();
    };

    $scope.doRefresh = function () {
      options.always = function () {
        $scope.$broadcast("scroll.refreshComplete");
      };
      HomeworkListService.request(options);
    };

    $scope.nextPage = function () {
      if (options.params.isHasNext) {
        options.params.pageNo++;
        options.always = function () {
          $scope.$broadcast("scroll.infiniteScrollComplete");
        };
        HomeworkListService.request(options);
      }
    };

    $scope.$on('$ionicView.loaded', function () {
      $scope.doRefresh();
    });
  })

  //教师列表
  .controller('ContactListCtrl', function ($scope, $ionicScrollDelegate, http, UserService) {

    var options = {
      other: true,
      list: []
    };

    $scope.options = options;

    $scope.showHide = function (block) {
      options[block] = options[block] ? false : true;
      $ionicScrollDelegate.resize();
    };

    $scope.doRefresh = function () {
      http.get('getSchoolAddressBook', {
        pointId: UserService.user.pointId
      }, function (response) {
        $scope.$broadcast("scroll.refreshComplete");
        options.list = response.data;
      }, function () {
        $scope.$broadcast("scroll.refreshComplete");
      });
    };
    $scope.$on('$ionicView.loaded', function () {
      $scope.doRefresh();
    })
  })

  //班级相册列表
  .controller('GalleryIndexCtrl', function ($scope, http, $stateParams, $ionicSideMenuDelegate, $ionicLoading, $ionicModal, $filter, $ionicScrollDelegate, xc, GalleryService, UploadService, UserService, ClassZoneService) {

    var options = {
      key: 'Gallery_' + UserService.user.id,
      params: {
        aid: UserService.user.id,
        classid: $stateParams.classid || '0'
      },
      list: []
    };

    $scope.UserService = UserService.user;

    $scope.options = options;

    $scope.class = ClassZoneService.class;

    $scope.viewTitle = $stateParams.name;

    $scope.changeClass = function (cls) {

      options.params.pageNo = 1;

      options.params.classid = cls.classid;

      GalleryService.request(options);

      $ionicSideMenuDelegate.toggleRight();

      $scope.viewTitle = cls.name;

      $ionicScrollDelegate.scrollTop();
    };

    $scope.toggleRight = function () {
      $ionicSideMenuDelegate.toggleRight();
    };

    $scope.toggleLeft = function () {
      $ionicSideMenuDelegate.toggleLeft();
    };

    $scope.doRefresh = function () {
      options.always = function () {
        $scope.$broadcast("scroll.refreshComplete");
      };
      GalleryService.request(options);
    };

    $scope.nextPage = function () {
      if (options.params.isHasNext) {
        options.params.pageNo++;
        options.always = function () {
          $scope.$broadcast("scroll.infiniteScrollComplete");
        };
        GalleryService.request(options);
      }
    };

    $scope.addAttachment = function () {

      var currentModal;

      $ionicModal.fromTemplateUrl('templates/choose-class.html', {
        scope: $scope
      }).then(function (modal) {

        currentModal = modal;

        currentModal.show();

        $scope.close = function () {
          currentModal.hide();
        };

        http.get('myclass', {aid: UserService.user.id}, function (response) {
          $scope.classList = {list: response.data};
        });

        $scope.classChange = function (classId) {

          currentModal.hide();

          UploadService.choose(classId, function () {

            $ionicLoading.show({
              template: '<i class="ion-ios-checkmark-outline"></i>上传成功！',
              animation: 'fade-in',
              showDelay: 0,
              duration: 500
            });

            $scope.doRefresh();
          });
        };
      });
    };

    $scope.$on('$ionicView.loaded', function () {
      $scope.doRefresh();
      ClassZoneService.load();
    });
  })

  //相册图片
  .controller('GalleryCtrl', function ($scope, http, $ionicTabsDelegate, $ionicModal, $stateParams, $ionicLoading, $filter, xc, UploadService, UserService, PicService) {

    $scope.addAttachment = function () {

      var currentModal;

      $ionicModal.fromTemplateUrl('templates/choose-class.html', {
        scope: $scope
      }).then(function (modal) {

        currentModal = modal;

        currentModal.show();

        http.get('myclass', {aid: UserService.user.id}, function (response) {
          $scope.classList = response.data;
        });

        $scope.close = function () {
          currentModal.hide();
        };

        $scope.classChange = function (classId) {

          currentModal.hide();

          UploadService.choose(classId, function () {

            $ionicLoading.show({
              template: '<i class="ion-ios-checkmark-outline"></i>上传成功！',
              animation: 'fade-in',
              showDelay: 0,
              duration: 500
            });

            var date = new Date();

            var dateStr = $filter('date')(date, 'yyyy-MM-dd');

            $scope.viewTitle = dateStr;

            classGallery.params.albumname = dateStr;

            classGallery.params.classids = classId;

            $scope.doRefresh();
          });
        };
      });
    };

    var classGallery = {
      key: 'classGallery_' + UserService.user.id,
      params: {
        albumname: $stateParams.name,
        classids: $stateParams.classId
      },
      error: null,
      items: []
    };

    $scope.classGallery = classGallery;

    $scope.viewTitle = $stateParams.name || '相册图片';

    $scope.cdn = xc.server.cdn;

    $scope.doRefresh = function () {
      classGallery.items = [];
      classGallery.params.pageNo = 1;
      classGallery.always = function () {
        $scope.$broadcast("scroll.refreshComplete");
      };
      PicService.getList(classGallery);
    };

    $scope.nextPage = function () {

      console.log('下一页喽');

      if (classGallery.params.isHasNext) {
        classGallery.params.pageNo++;
        classGallery.always = function () {
          $scope.$broadcast("scroll.infiniteScrollComplete");
          classGallery.loaded = true;
          // converImg(classGallery.items);
        };
        PicService.getList(classGallery);
      }
    };

    $scope.$on('$ionicView.loaded', function () {
      $scope.doRefresh();
    });
  })

  //图片预览
  .controller('gallerySliderController', function ($scope, $ionicSlideBoxDelegate) {
    $scope.delete = function () {
      console.log('deleteModal');
      var index = $ionicSlideBoxDelegate.currentIndex();
      console.log($scope.slides);
      console.log(index);
      $scope.slides.splice(index, 1);
      console.log($scope.slides);
      if (index == 1 && $scope.slides.length == 1) {
        $scope.closeModal();
      } else {
        $ionicSlideBoxDelegate.update();
      }
      // $rootScope.doRefresh();
    };
  })

  //通讯簿列表
  .controller('ContactCtrl', function ($scope, http, $stateParams) {
    $scope.doRefresh = function () {
      http.get('getStudentInfo', {
        studentid: $stateParams.studentId
      }, function (response) {
        $scope.$broadcast("scroll.refreshComplete");
        $scope.student = response.data;
      }, function () {
        $scope.$broadcast("scroll.refreshComplete");
      });
    };
    $scope.$on('$ionicView.loaded', function () {
      $scope.doRefresh();
    })
  })

  //意见反馈
  .controller('AdviceCtrl', function ($scope, http, $state, $ionicLoading, $timeout, UserService) {

    var vm = {content: null};

    vm.id = UserService.user.id;
    vm.pointId = UserService.user.pointId;
    vm.name = UserService.user.name;

    $scope.vm = vm;

    $scope.doAdvice = function () {

      http.get('advice', {
        name: encodeURI(encodeURIComponent((vm.name))),
        content: encodeURI(encodeURIComponent((vm.content)))
      }, function () {
        $ionicLoading.show({
          template: '提交成功，非常感谢您的反馈',
          animation: 'fade-in',
          showBackdrop: false,
          showDelay: 0
        });
        $timeout(function () {
          $state.go('tab.account');
          $ionicLoading.hide();
        }, 800);
      });
    };
  })

  //字体设置
  .controller('FontCtrl', function ($scope) {

    $scope.font = {size: window.localStorage.getItem('fontSize') || 14};

    $scope.zoom = function () {
      window.localStorage.setItem('fontSize', $scope.font.size);
    };
  })

  //欢迎页面
  .controller('WelcomeCtrl', function ($scope, $state, $ionicLoading, $interval, xc) {

    var adv = {image: 'img/adv.jpg'};

    $scope.time = xc.app.advTime;

    $scope.adv = adv;

    $scope.close = close;

    $scope.opacity = 1;

    var timer = null;
    var timer2 = null;

    var close = function () {
      if (angular.isDefined(timer)) {
        $interval.cancel(timer);
        timer = null;
        if (!window.localStorage.getItem('user')) {
          $state.go('login');
        } else {
          $state.go('tab.home');
        }
      }

      if (angular.isDefined(timer2)) {
        $interval.cancel(timer2);
        timer2 = null;
      }
    };

    //提交按钮事件
    $scope.close = function () {
      close();
    };

    $scope.$on('$ionicView.enter', function () {
      console.log('$ionicView.enter');
      timer = $interval(function () {
        console.log('tik');
        $scope.time--;
        if ($scope.time == 1) {
          timer2 = $interval(function () {
            $scope.opacity -= 0.01;
            if ($scope.opacity <= 0.3) {
              $scope.opacity = 0;
            }
          }, 10);
        }
        if ($scope.time == 0) {
          close();
        }
      }, 1000);
    });
  })

  //个人中心
  .controller('AccountCtrl', function ($scope, $ionicLoading, xc, CacheService, UserService) {

    $scope.user = UserService.user;

    $scope.cacheSize = CacheService.size;

    $scope.cleanup = function () {

      $ionicLoading.show({
        template: '正在清理缓存...',
        animation: 'fade-in',
        showBackdrop: false,
        showDelay: 0
      });

      var size = CacheService.size;

      $ionicLoading.show({
        template: '成功清理' + size.value + size.unit + '缓存!',
        animation: 'fade-in',
        showBackdrop: false,
        duration: 500,
        showDelay: 0
      });

      CacheService.clear();

      $scope.cacheSize = CacheService.size;
    };
    // $scope.v = window.localStorage.getItem('version');
  })

  //个人设置
  .controller('profileCtrl', function ($scope, $state, $location, $ionicPopup, $ionicLoading, $ionicActionSheet, xc, UserService) {

    $scope.profile = UserService.user;

    $scope.user = {
      oldpassword: '',
      newpassword: ''
    };
    $scope.user.realname = $scope.profile.name;
    $scope.user.telphone = $scope.profile.telphone;

    //修改真实姓名
    $scope.setRealName = function () {
      UserService.updateRealName($scope);
    };

    //修改电话号码
    $scope.setTelPhone = function () {
      UserService.updateTelPhone($scope);
    };

    //修改密码
    $scope.resetpwd = function () {
      UserService.updatePassword($scope);
    };

    $scope.uploadAvatar = function () {
      $ionicActionSheet.show({
        buttons: [
          {text: '<i class="icon ion-images"></i>从相册中选取'},
          {text: '<i class="icon ion-camera"></i>拍照'}
        ],
        titleText: '选择头像来源',
        cancelText: '取消',
        buttonClicked: function (index) {

          var options = {
            quality: 75,
            destinationType: Camera.DestinationType.FILE_URI,
            correctOrientation: true,
            targetWidth: 210,
            targetHeight: 210,
            allowEdit: true,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            sourceType: index
          };

          navigator.camera.getPicture(function (imageURI) {

            var image = document.getElementById('myImage');

            image.src = imageURI;

            console.log('上传头像');

            var options = new FileUploadOptions();

            //用于设置参数，对应form表单里控件的name属性，这是关键，废了一天时间，完全是因为这里，这里的参数名字，和表单提交的form对应
            options.fileKey = "file";

            console.log('imageURI:' + imageURI);

            options.fileName = imageURI.substr(imageURI.lastIndexOf('/') + 1);

            console.log('fileName:' + options.fileName);

            //如果是图片格式，就用image/jpeg，其他文件格式上官网查API
            options.mimeType = "image/jpeg";

            options.chunkedMode = false;

            var params = {};

            params.userId = UserService.user.id;

            options.params = params;

            //options.mimeType = "multipart/form-data";//这两个参数修改了，后台就跟普通表单页面post上传一样 enctype="multipart/form-data"

            //这里的uri根据自己的需求设定，是一个接收上传图片的地址
            var uri = encodeURI(xc.server.base + 'uploadAvatar');

            var ft = new FileTransfer();

            var uploadSuccess = function (r) {
              console.log('图片上传完成');
              var res = JSON.parse(r.response);
              console.log('Success getPicture image is ' + imageURI);
              UserService.updateAvatar(res.data);
            };

            var uploadError = function (e) {
              console.log('图片上传失败');
              console.log(JSON.stringify(e));
              $ionicLoading.show({
                template: '图片上传失败...',
                showBackdrop: false,
                duration: 3000
              });
            };
            ft.upload(imageURI, uri, uploadSuccess, uploadError, options);
          }, function (message) {
            // alert('Failed because: ' + message);
          }, options);

          return true;
        }
      });
    };

    //退出登录
    $scope.logout = function () {
      UserService.logout();
    };
  })
;
